/*
 * Copyright (C) 2013 Darth Affe <http://wyrez.org> and contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package org.wyrez.shootingstars.states;

import com.jme3.app.state.AppState;

/**
 *
 * @author Darth Affe
 */
public enum State {

    NONE(null), START(StartState.class), MENU(MenuState.class),
    LOADING(LoadingState.class), GAME(GameState.class), 
    SELECTTRACK(SelectTrackState.class), YTDOWNLOAD(YTDownloadState.class),
    OPTIONS(OptionsState.class), HIGHSCORE(HighscoreState.class), 
    FILEMETAINFO(FileMetaInfoState.class);
    private static State currentState = State.NONE;
    private static State previousState = State.NONE;
    private final Class clazz;

    private State(Class<? extends AppState> clazz) {
        this.clazz = clazz;
    }

    public Class<? extends AppState> getClazz() {
        return clazz;
    }

    static void setState(State currentGameState) {
        previousState = State.currentState;
        State.currentState = currentGameState;
    }

    public static State getState() {
        return currentState;
    }

    public static State getPreviousState() {
        return previousState;
    }
}
